ITPub博客

首页 > 应用开发 > Java > java培训教程分享:Java中用户如何自定义异常?

java培训教程分享:Java中用户如何自定义异常?

原创 Java 作者:千锋教育qyf 时间:2021-12-02 18:13:19 0 删除 编辑

  我们在学习 java技术的时候应该有了解过,在java中是定义了很多的异常类的,虽然这些大量异常类可以帮助我们描述编程时出现的大部分异常情况,但是在程序开发中有时可能需要描述程序中特有的异常情况,例如在设计divide()方法时不允许被除数为负数。为了解决这样的问题,Java允许用户自定义异常,但自定义的异常类必须继承自Exception或其子类。接下来通过一个案例来学习自定义异常的创建,如例4-35所示。

   java培训教程分享:Java中用户如何自定义异常?

  //下面的代码是自定义一个异常类继承自 Except ion

  public DivideByMinusException extends Exception

  public DivideByMinusException (){

  super () //调用Exception无参的构造方法

  }

  public DivideByMinusException (String message){

  //调用 Exceptlon有参的构造方法

  }

  }

  在实际开发中,如果没有特殊的要求,自定义的异常类只需继承Exception类,在构造方法中使用super()语句调用Exception的构造方法即可。

  既然自定义了异常,那么该如何使用呢?这时就需要用到throw关键字,在程序指定位置通过throw关键字抛出自定义的异常对象,然后对抛出的异常进行异常处理。

  接下来重新对例4-33中的divide()方法进行改写,在divide()方法中判断被除数是否为负数,如果为负数,就是用throw关键字向调用者抛出自定义的DivideByMinusException异常对象,如例4-36所示。

  例4-36 Example36.java

  public class Exanple36 (

  //下面的方法实现了两个整数相除

  public static int divide(int x,int y) throws DivideByMinuaException{

  if (y ==0){

  //使用throw关键字声明异常对象

  throw new DivideByMinuaException("除数是0")

  }

  int result. =x / yL; //定义一个变量resulc记录两个散相除的结果

  return result; //将结果返回

  publlc static void main(String[] args) {

  try {

  int result =divide (4, 0);

  System.out.println(result);

  } catch (DivideByMinuaException e) {

  Syatem.out.println(“捕获的异常信息为:" +e.getMesaage()):

  }

  }

  }

  运行结果如下图所示:

java

  例4-36中,divide()方法通过逻辑判断对除法运算的除数是否为0进行了判断,如果除数为0就使用throw关键字抛出自定义的DivideByMinusException异常对象,然后通过throws关键字抛出异常,并在最后通过try…catch语句捕获异常。从图4-40可以看出,程序执行后判断出除数为0,抛出了指定的异常信息。


来自 “ ITPUB博客 ” ,链接:http://blog.itpub.net/69996644/viewspace-2845492/,如需转载,请注明出处,否则将追究法律责任。

请登录后发表评论 登录
全部评论
千锋教育隶属于北京千锋互联科技有限公司,以“初心至善,匠心育人”为核心价值观,致力于打造职业教育全产业链人才服务平台,公司总部位于北京,拥有全国一体化就业保障服务,成为学员信赖的职业教育品牌。 每年有数百万名学员受益于千锋组织的技术研讨会、技术培训课、网络公开课及免费教学视频。

注册时间:2021-03-17

  • 博文量
    527
  • 访问量
    136482